Doomsday Engine - Bug #2378

Hitscan spread changes depending on the on view angle
2019-12-24 09:19 - RemiliaScarlet

Status: Closed Start date: 2019-12-24
Priority: Normal % Done: 100%
Assignee: skyjake

Category: Defect

Target version: 23

Description

The spread that gets applied to hitscans from the player's weapon seems to depend on the angle the player is looking at. For
example, if you fire the super shotgun while looking straight ahead, it behaves as expected, with hitscans covering a wide range.

The higher you look up (or the more you look down), the tighter this spread becomes. When looking straight up, all of the hitscans hit
in the exact same place. But what | would expect is for the same kind of spread to occur.

Associated revisions

Revision 282042a4 - 2019-12-28 14:52 - skyjake

Fixed|Doom: Bullet trajectories when looking up and down

Apply a true 3D rotation to bullet trajectories when calculating random variations of individual bullets. This fixes the problem that looking up/down at a
steep angle would cause the trajectories to get smaller offsets.

All the bullet-firing weapons are affected: pistol, shotgun, super shotgun, chaingun.

IssuelD #2378

History

#1 - 2019-12-24 09:40 - skyjake
- Category set to Defect

- Target version set to Vanilla / Gameplay

#2 - 2019-12-27 21:12 - skyjake

This happens because the random variations of the bullet directions are not applied in true 3D. The direction is specified as a yaw angle and a Z
slope, and the variations simply modify those values with small offsets.

What is needed is to calculate the bullet direction changes as 3D vectors and then convert those back to corresponding angle + slopes.

#3 - 2019-12-28 14:54 - skyjake

- Status changed from New to Resolved

- Assignee changed from Deng Team to skyjake

- Target version changed from Vanilla / Gameplay to 2.3

- % Done changed from 0 to 100

#4 - 2020-12-08 08:27 - skyjake

- Status changed from Resolved to Closed
